Subject: bug#20499: [PROPOSED PATCH] C-x 8 shorthands for curved quotes, , Euro, etc.

From: Eli Zaretskii <[email-masked]>
Date: Mon, 11 May 2015 22:10:49 +0300

> Date: Mon, 11 May 2015 11:48:36 -0700
> From: Paul Eggert <[email-masked]>
> CC: [email-masked], [email-masked]
> 
> On 05/11/2015 07:54 AM, Eli Zaretskii wrote:
> > IOW, the above selection is highly filtered using some unspecified rules
> 
> Sure, and I expect that what Wikipedia has done is seen which characters 
> get used the most, give a trivial UI for the most-commonly used dozen or 
> so non-ASCII characters, a simple UI for the most-commonly used 
> few-hundred non-ASCII characters, and a more-complex UI for the rest.  
> It's a reasonable design approach.

But it's not Emacsy, not to my palate.  Emacs never arbitrarily limits
the user without offering some ways to lift the limits.

> > For example, if you know that the character you are looking for is 
> > some form of a Latin 'a', then we could present only those (there are 
> > 36 of them in the current UCD). 
> 
> That all sounds good, for users who know that there's a way to get that 
> list of "A"-like characters.

The way I envision it, the UI to specify the characters you are
looking for will have a widget named "Looks like ..." or "Base
character", and users who are looking for 'a' with some diacriticals
will type "a" there.

> Perhaps a top-level menu that gives a dozen or so of the most-common
> characters

I think "most-common characters" can only be reasonably offered once
the user supplied a language or script.  Most-common Latin characters
are different from most-common Cyrillic characters or Greek or Hebrew
or Math symbols.

> and also says "type an "A" to get the "A"-like letters", and "press
> this button to get Greek", etc.

I don't think a single button will do.  At least it should be possible
to press both "Greek" and "with/without diacriticals", and possibly
also other constraints, like with/without punctuation.

IOW, we need to let users specify several constraints, and display
whatever matches them.  If they only specify the script, like "Latin",
they will see the list similar to what you presented, perhaps in
several parts with a "more" button.